//Marijuana bruh
//Smooth BL_ID:7353
//### Item
datablock AudioProfile(BongShot1Sound)
{
   filename    = "./Bonghit.wav";
   description = AudioClose3d;
   preload = true;
};


datablock ParticleData(BongSmokeParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 15000;
	lifetimeVarianceMS   = 5345;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.5 0.5 0.5 0.9";
	colors[1]     = "0.5 0.5 0.5 0.0";
	sizes[0]      = 0.15;
	sizes[1]      = 0.25;

	useInvAlpha = false;
};

datablock ParticleEmitterData(BongSmokeEmitter)
{
  ejectionPeriodMS = 310;
   periodVarianceMS = 22;
   ejectionVelocity = 1.0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 33;
   thetaMax         = 59;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "BongSmokeParticle";
};

datablock ExplosionData(BongExplosion)
{
  lifeTimeMS = 200;
  emitter[0] = BongSmokeEmitter;
  faceViewer = true;
  explosionScale = "1 1 1";
};

datablock ProjectileData(PotEffect)
{
  uiName = "";
  explosion = BongExplosion;
  lifetime = 1;
  fadeDelay = 1;
  explodeOnDeath = true;
};

datablock ProjectileData(BongProjectile)
{
   projectileShapeName = "./Blank.dts";
   directDamage        = 125;
   directDamageType    = $DamageType::Bong;
   radiusDamageType    = $DamageType::Bong;

   brickExplosionRadius = 1;
   brickExplosionImpact = false;          
   brickExplosionForce  = 1;
   brickExplosionMaxVolume = 1;          
   brickExplosionMaxVolumeFloating = 2;  

   impactImpulse	     = 1200;
   verticalImpulse	  = 1400;
 

   muzzleVelocity      = 200;
   velInheritFactor    = 1;

   armingDelay         = 00;
   lifetime            = 1;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = true;
   gravityMod = 0.0;

   hasLight    = true;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";

   uiName = "Bong";
};



datablock ItemData(BongItem)
{
  category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./Da_Bong.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Bong";
	iconName = "./Icon_Weed";
	//iconName = "";
	doColorShift = true;
	colorShiftColor = "1 1 1 1";

	 // Dynamic properties defined by the scripts
	image = BongImage;
	canDrop = true;

	//maxAmmo = 10;
	//canReload = 1;
  
};

//### Item Image

datablock shapeBaseImageData(BongImage)
{
  shapeFile = "./Da_Bong.dts";
  emap = true;
  mountPoint = 0;
   offset = "0 0.1 0.03";
   eyeOffset = "0 0 0";
   rotation = eulerToMatrix( "0 0.3 360" );
  correctMuzzleVector = true;
  className = "WeaponImage";
  item = BongItem;
  ammo = "";
  projectile = "BongProjectile";
  projectileType = Projectile;
  melee = false;
  shellExitDir        = "1.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 9.5;
  doReaction = false;
  armReady = true;
  doColorShift = true;
  colorShiftColor = "1 1 1 1";

  stateName[0] = "Activate";
  stateTimeoutValue[0] = 0.2;
  stateTransitionOnTimeout[0] = "Ready";
  stateSound[0] = weaponSwitchSound;

  stateName[1] = "Ready";
  stateTransitionOnTriggerDown[1] = "Charge";
  stateAllowImageChange[1] = true;

  stateName[2] = "Charge";
  stateTransitionOnTimeout[2] = "Armed";
  stateTimeoutValue[2] = 0.2;
  stateWaitForTimeout[2] = false;
  stateTransitionOnTriggerUp[2] = "AbortCharge";
  stateScript[2] = "onCharge";
  stateAllowImageChange[2] = false;

  stateName[3] = "AbortCharge";
  stateTransitionOnTimeout[3] = "Ready";
  stateTimeoutValue[3] = 0.3;
  stateWaitForTimeout[3] = true;
  stateScript[3] = "onAbortCharge";
  stateAllowImageChange[3] = false;

  stateName[4] = "Armed";
  stateTransitionOnTriggerUp[4] = "Fire";
  stateAllowImageChange[4] = false;

  stateName[5] = "Fire";
  stateTransitionOnTimeout[5] = "Smoke";
  stateTimeoutValue[5] = 0.2;
  stateFire[5] = true;
  stateScript[5] = "onSelfUse";
  stateSound[2]	= BongShot1Sound;
  stateWaitForTimeout[5] = true;
  stateAllowImageChange[5] = false;
  
  stateName[6] = "Smoke";
	stateEmitter[6]					= BongSmokeEmitter;
	stateEmitterTime[6]				= 1;
	stateEmitterNode[6]				= "muzzleNode";
	stateTimeoutValue[6]            = 0.01;
	stateTransitionOnTimeout[6]     = "Reload";

	stateName[7]			= "Reload";
	stateSequence[7]                = "Reload";
	stateTransitionOnTriggerUp[7]     = "Ready";
	stateSequence[7]	= "Ready";
};

function BongImage::onMount(%this,%obj,%slot) { bottomPrint(%obj.client,"\c6Hold down \c3Left Mouse \c6to use bong",5); }
function BongImage::onCharge(%this,%obj,%slot) { %obj.playThread(2,root); }
function BongImage::onAbortCharge(%this,%obj,%slot) { %obj.playthread(2,root); }

function SM_PotEffect(%obj,%duration)
{
  if(!isObject(%obj)) return;
  if(!isObject(%obj.client)) return;
  cancel(%obj.PotEffect);
  if(%duration < 0) { %obj.client.setControlCameraFov(90); return; }
  %obj.client.setControlCameraFov(140 + (getRandom()*20));
  %duration -= 1;
  %obj.PotEffect = schedule(100,0,Sm_PotEffect,%obj,%duration);

}



function BongImage::onSelfUse(%this,%obj,%slot)
{
      
	  %obj.spawnExplosion(gc_PotEffect,"1 1 1");
      cancel(%obj.PotEffect);
      %obj.PotEffect = schedule(100,0,Sm_PotEffect,%obj,$GCStuff::PotDuration * 10);
      %currSlot = %obj.currTool;
      %obj.tool[%currSlot] = 0;
      %obj.weaponCount--;
      messageClient(%obj.client,'MsgItemPickup','',%currSlot,0);
      serverCmdUnUseTool(%obj.client);
}
